From 39b49cf2fbc62720f2a0cf3602ad47088efce881 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 21 2016 13:14:28 +0000
Subject: [PATCH 342/1001] Merge #122 `Add long-form stuff with the new lexer interface from fedmsg.meta.`


---

diff --git a/hubs/widgets/feed.py b/hubs/widgets/feed.py
index 486ef68..8ae603f 100755
--- a/hubs/widgets/feed.py
+++ b/hubs/widgets/feed.py
@@ -12,6 +12,9 @@ import datanommer.models
 import arrow
 import munch
 import requests
+import six
+
+import pygments.formatters
 
 import flask
 
@@ -19,6 +22,8 @@ import hubs.validators as validators
 
 import datetime
 import logging
+import uuid
+
 log = logging.getLogger('hubs')
 
 import fedmsg.config
@@ -110,13 +115,26 @@ def data(session, widget, username, fmn_context):
     # TODO - sort messages and remove duplicates
 
     # Smash multiple messages into single ones
-    matches = fedmsg.meta.conglomerate(matches, **config)
+    matches = fedmsg.meta.conglomerate(matches, lexers=True, **config)
 
     # Apply some html markup to the subtitles for extra fanciness.
     for match in matches:
         match['markup'] = apply_markup(match)
         for idx, constituent in match['msg_ids'].items():
             constituent['markup'] = apply_markup(constituent)
+            if constituent['long_form'] != constituent['subtitle']:
+                if constituent.get('lexer'):
+                    constituent['long_form'] = pygments.highlight(
+                        constituent['long_form'],
+                        constituent['lexer'],
+                        pygments.formatters.HtmlFormatter(style='monokai'),
+                    )
+                else:
+                    markup = u"<h5>{long_form}</h5>".format(**constituent)
+                    constituent['long_form'] = markup
+
+        # And tack on a unique identifier for each top level entry.
+        match['dom_id'] = six.text_type(uuid.uuid4())
 
     return dict(
         matches=matches,
